	;PiXross
#packopt name "pixross"
#packopt xsize 320
#packopt ysize 200
#packopt hide 1
#packopt runtime "hsp2c.hrt"

#epack "char.bmp"
#epack "title.bmp"
#epack "unknown.bmp"

#epack "stuff.wav"
#epack "title.wav"
#epack "start.wav"
#epack "select.wav"
#epack "page.wav"
#epack "puzzle.wav"
#epack "put.wav"
#epack "erase.wav"
#epack "help.wav"
#epack "nohelp.wav"
#epack "clear.wav"
#epack "escape.wav"

	screen 0,320,200,2,dispx-320/2,dispy-200/2:title "PiXross ver.1.1 - by Murachue 2004.":randomize
	buffer 2:buffer 3,32,32:buffer 4:picload "title.bmp":buffer 5:picload "char.bmp":gsel 0
	onexit *exit

	cls:ps=13,13:m="NOW LOADING...":gosub *chr:gsel 0,1:wait 1

	dim clear,256
	exist "clear.dat":if strsize!-1{
		sdim buf,256:bload "clear.dat",buf,256
		repeat 256
			peek clear.cnt,buf,cnt
		loop
	}

	sndload "stuff.wav",0
	sndload "title.wav",1,1
	sndload "start.wav",2,2
	sndload "select.wav",3
	sndload "page.wav",4
	sndload "puzzle.wav",5
	sndload "put.wav",6
	sndload "erase.wav",7
	sndload "help.wav",8
	sndload "nohelp.wav",9
	sndload "clear.wav",10
	sndload "escape.wav",11

	gmode 0:pos 320-157/2,200-37/2:gcopy 4,0,0,157,37
	ps=40-25,24:m="BUILD 2004/02/06 06:43 PM":gosub *chr
	snd 0
	ps=10,15:w=10:m="PIXROSS BY MURACHUE.":gosub *pchr
	w=30:gosub *waits:snd 1

	repeat
	ps=9,18
	if (cnt\100)<50:m="CLICK TO BEGIN PIXROSS":else:m="                      "
	gosub *chr
	wait 1
	stick ky,,1:if ky&256:break
	loop

	snd 2

	cls:ps=13,13:m="NOW LOADING...":gosub *chr

	sft=0
	repeat:exist "stage\\"+cnt+".bmp":if strsize=-1:maxp=cnt:break
	loop

	dim wxs,maxp:dim wys,maxp
	buffer 6,maxp+2*16,32

	gsel 2:picload "unknown.bmp"
	gsel 6:pos 0,0:gcopy 2,0,0,32,32

	repeat maxp
	gsel 2:picload "stage\\"+cnt+".bmp":wxs.cnt=winx:wys.cnt=winy
	gsel 6:pos cnt+2*16,0:gcopy 2,0,0,wxs.cnt,wys.cnt
	loop
	gsel 0
*escape
	max=maxp:if max>12:max=12
	if 12>(maxp-(sft*4)):max=maxp-(sft*4)
*redr
	redraw 0
	color 255,255,255:boxf 0,0,winx,winy

	gmode 0

	pos 1,1:gcopy 4,0,0,157,37
	ps=24,2:m="STAGE SELECT":gosub *chr
	ps=1,5:m="CLICK THE STAGE AND PRESS \"GO\"!":gosub *chr
	pos 0,49:line 320,49

	repeat max
	x=cnt\4:y=cnt/4:st=cnt+(sft*4):gosub *prstg
	loop
*stglop
	redraw 0:bsel=0
	x=288:y=50:xl=32:yl=50:gosub *box:if s=1:bsel=1
	ps=37,9:m="@@":poke m,0,128+7:poke m,1,128+7:gosub *chr
	x=288:y=100:xl=32:yl=50:gosub *box:if s=1:bsel=2
	ps=37,15:m="GO":gosub *chr
	x=288:y=150:xl=32:yl=50:gosub *box:if s=1:bsel=3
	ps=37,21:m="@@":poke m,0,128+8:poke m,1,128+8:gosub *chr
	redraw 1

	stick ky,,1:if ky&256{
		if (mousey>50)&(mousex<288){
			a=mousey-50/56*4+(mousex/72)+(sft*4)
			if a<maxp:if sel!a:sel=a:snd 3:goto *redr
		}
		if bsel=1:goto *sfm
		if bsel=2:goto *go
		if bsel=3:goto *sfp
	}
	wait 1
	goto *stglop
*go
	snd 5

	redraw 0:color 255,255,255:boxf 0,0,winx,winy:clrobj:gmode 0
	st=sel+1

	gsel 2:pos 0,0:gcopy 6,sel+2*16,0,16,16:wx=wxs.sel:wy=wys.sel
	gsel 0

	color 128,128,128
	repeat 16-wy,wy:boxf 120,200-129-8+(cnt*8),320-9,200-129+(cnt*8):loop
	repeat 16-wx,wx:boxf 320-129-8+(cnt*8),0,320-129+(cnt*8),200-9:loop
	color 192,192,192
	repeat 17:pos 120,200-129-8+(cnt*8):line 320-8,200-129-8+(cnt*8):loop
	repeat 17:pos 320-129-8+(cnt*8),0:line 320-129-8+(cnt*8),200-8:loop

	pos 2,2:gcopy 4,0,0,157,37

	ps=1,6:m="STAGE No."+st:gosub *chr
	swx=wx:swy=wy:str swx:str swy
	kt=2:m=swx:gosub *spc:swx=m:m=swy:gosub *spc:swy=m
	ps=2,7:m="SIZE:"+swx+"x"+swy:gosub *chr

	repeat wx:cc=cnt:m="":c=0:gsel 2
	repeat wy:pget cc,cnt:gosub *hantei1:loop:gosub *hantei2
	gsel 0:mm=m:strlen ll,mm:repeat ll:ps=cc+23,8-ll+cnt:m=" ":strmid m,mm,cnt,1:gosub *chr:loop
	loop

	repeat wy:cc=cnt:m="":c=0:gsel 2
	repeat wx:pget cnt,cc:gosub *hantei1:loop:gosub *hantei2
	gsel 0:strlen ll,m:ps=15+8-ll,8+cnt:gosub *chr
	loop

	redraw 1

	dim point,wx,wy:hlp=3:comp=0
*mainlop
	;;;;;
	;drawƁA蔻(gosub)B
	;XV́AubNNbNŃubNonly,
	;{^͏ɂ(ͥ)!!
	;
	;ƂɃAj[VقB
	;;;;;

	wait 1

	redraw 0

	sc=0:sel=-1
	ps=2,10:m="RESTART":gosub *bchr
	ps=2,14:m="HELPx"+hlp:gosub *bchr
	ps=2,18:m="ESCAPE":gosub *bchr

	stick ky,,1
	if ky&256{
		if(mousex>=184)&(mousey>=64)&(mousex<=(wx*8+184))&(mousey<(wy*8+64)){
			x=mousex-184/8:y=mousey-64/8
			if(x<wx)&(y<wy){
				point.x.y=point.x.y+1\2
				if point.x.y=1:snd 6
				if point.x.y=0:snd 7
				color 255-(point.x.y*255),255-(point.x.y*255),255-(point.x.y*255)
				boxf x*8+184,y*8+64,x*8+184+6,y*8+64+6
			}
			gosub *chkok
			hlp=0
		}
		if sel=0:sel=st-1:goto *go
		if sel=1:gosub *help
		if sel=2:sel=st-1:snd 11:goto *escape
	}

	redraw 1

	if comp=1:goto *finish

	goto *mainlop
*finish
	snd 10

	redraw 0:wait 1
	color 255,255,255:boxf 0,0,winx,winy

	color 128,128,128
	repeat 16-wy,wy:boxf 120,200-129-8+(cnt*8),320-9,200-129+(cnt*8):loop
	repeat 16-wx,wx:boxf 320-129-8+(cnt*8),0,320-129+(cnt*8),200-9:loop
	color 192,192,192
	repeat 17:pos 120,200-129-8+(cnt*8):line 320-8,200-129-8+(cnt*8):loop
	repeat 17:pos 320-129-8+(cnt*8),0:line 320-129-8+(cnt*8),200-8:loop

	gmode 0:pos 2,2:gcopy 4,0,0,157,37

	ps=1,6:m="STAGE No."+st:gosub *chr

	repeat wx:x=cnt:repeat wy:y=cnt
		color 255-(point.x.y*255),255-(point.x.y*255),255-(point.x.y*255)
		boxf x*8+184,y*8+64,x*8+184+6,y*8+64+6
	loop:loop
	redraw 1

	w=25:gosub *waits

	repeat 64
		redraw 0
		gmode 3,,,cnt*4
		repeat wx:x=cnt:repeat wy:y=cnt
			if point.x.y!0{
				gsel 3:gzoom 7,7,2,x,y,1,1:gsel 0
				pos x*8+184,y*8+64:gcopy 3,0,0,7,7
			}
		loop:loop
		redraw 1
		wait 1
	loop

	w=20:gosub *waits

	st-:clear.st=1:gosub *save
	sel=st

	goto *escape
*waits
	gettime ss,6:gettime ms,7
	ss=ss*1000+ms+(w*100):if ss>60000:ss-=60000:sw=1:else:sw=0

	repeat:wait 1:gettime s,6:gettime ms,7:s=s*1000+ms
	if (sw=1)&(s<ss):sw=0
	if (sw=0)&(s>=ss):break
	loop
	return
*chkok
	comp=1:gsel 2
	repeat wx:x=cnt:repeat wy:y=cnt
	pget x,y:if(rval=255)&(gval=255)&(bval=255):a=0:else:a=1
	if point.x.y!a:comp=0:break
	loop:if comp=0:break
	loop
	gsel 0:return
*help
	if hlp=0:snd 9:return
	hlp-:gsel 2
	repeat:wait 1:rnd x,wx:rnd y,wy
	pget x,y:if((rval!255)|(gval!255)|(bval!255))&(point.x.y=0){
		point.x.y=1
		gsel 0:color 0,0,0
		boxf x*8+184,y*8+64,x*8+184+6,y*8+64+6
		break
	}
	loop:gsel 0:snd 8
	return
*hantei1
	if (rval=255)&(gval=255)&(bval=255){
		if c>0{
			if c<10{
				m+=""+c
			}else{
				m+="@":strlen l,m:poke m,l-1,118+c
			}
		}
		c=0
	}else{
		c+
	}
	return
*hantei2
	if c>0{
		if c<10{
			m+=""+c
		}else{
			m+="@":strlen l,m:poke m,l-1,118+c
		}
	}
	return
*sfp
	if (sft+1*4)<maxp{
		sft+:snd 4:if 12>(maxp-(sft*4)):max=maxp-(sft*4)
		goto *redr
	}else:snd 9
	goto *stglop
*sfm
	if sft>0{
		sft-:snd 4:if 12<=(maxp-(sft*4)):max=12:else:max=maxp-(sft*4)
		goto *redr
	}else:snd 9
	goto *stglop
*prstg
	if sel=st:color 96,192,255:else:color 255,255,255
	boxf x*72,y*56+50,x*72+71,y*56+50+55

	gsel 2:pos 0,0:gcopy 6,st+2*16,0,16,16:wx=wxs.st:wy=wys.st
	wwx=wx:wwy=wy

	if clear.st=0:buffer 2,32,32:pos 0,0:gcopy 6,0,0,32,32:wwx=32:wwy=32

	gsel 3:pos 0,0:gzoom 32,32,2,0,0,wwx,wwy
	gsel 0:color 255,255,255:gmode 4,,,255:pos 72*x+22,56*y+52:gcopy 3,0,0,32,32
	swx=wx:swy=wy:str swx:str swy
	kt=2:m=swx:gosub *spc:swx=m:m=swy:gosub *spc:swy=m
	ps=x*9,y*7+11:ex=1:st+:m="No."+st:gosub *chr
	ps=x*9,y*7+12:ex=1:m=" "+swx+"x"+swy:gosub *chr
	return
*spc
	strlen l,m:if kt>l:repeat kt-l:m=" "+m:loop
	return
*pchr
	mm=m:strlen l,mm:repeat l:strmid m,mm,cnt,1
	gosub *chr:ps.0+:wait w
	loop
	return
*bchr
	strlen l,m

	x=ps.0-1*8:y=ps.1-1*8:xl=l+2*8:yl=24:gosub *box
	if s=1:sel=sc

	gosub *chr

	sc+
	return
*box
	if(mousex>=x)&(mousey>=y)&(mousex<(x+xl))&(mousey<(y+yl)):s=1:else:s=0

	color 128,128,128
	boxf x,y,x+xl-1,y+yl-1
	if s=0:color 192,192,192:else:color 96,192,255
	boxf x+1,y+1,x+xl-2,y+yl-2
	return
*chr
	color 255,255,255
	strlen l,m:repeat l:peek a,m,cnt:a-=32
	if a!0:gmode 4,,,255:else:if ex=0:gmode 1:else:gmode 4,,,255
	pos ps.0+cnt*8,ps.1*8:gcopy 5,a\16*8,a/16*8,8,8
	loop
	color 0,0,0:ex=0
	return
*exit
	gosub *save
	end
*save
	sdim buf,256:repeat 256:poke buf,cnt,clear.cnt:loop
	skiperr 1:bsave "clear.dat",buf,256:e=err:skiperr 0
	if e!0{
	dialog {"clear.datɏ߂܂łB
		̂߁ANA󋵂͕ۑ܂B\n
		CD-ROMsĂꍇ́An[hfBXNɃRs[A
		ǂݎp͂Ƃɂ
		NA󋵂ۑ悤ɂȂ܂B\n
		n[hfBXNɃRs[Ăꍇ́A
		clear.datǂݎpɂȂĂȂmFĂB"},1,"ERROR!"
	}
	return